#pragma once
#include "RenderTechnique.h"

/**
	@brief Base abstract class of rendering a particle system with the spherical billboard method. 	

	This technique only defines that the rendering of the object needs depth information of the scene from the player camera's view.
*/
class SBBRenderTechnique : virtual public RenderTechnique
{
public:
	/**
		@brief Constructor.

		@param parentRenderable the object to operate on
		@param parentTechniqueGroup the TechniqueGroup this RenderedTechnique is attached to
	*/
	SBBRenderTechnique( 
							ElementaryRenderable* parentRenderable,
							TechniqueGroup* parentTechniqueGroup
							);
	virtual ~SBBRenderTechnique();	
};