#include "OgreTechniqueGroup.h"


OgreTechniqueGroup::~OgreTechniqueGroup()
{
	std::vector<OgreRenderTechnique*>::iterator it = renderTechniques.begin();
	std::vector<OgreRenderTechnique*>::iterator itend = renderTechniques.end();
	while(it != itend)
	{
		OgreRenderTechnique* rt = *it;
		delete rt;
		it++;
	}	
	renderTechniques.clear();	
}

void OgreTechniqueGroup::addRenderTechnique(RenderTechnique* technique)
{
	renderTechniques.push_back( technique->asOgreRenderTechnique() );
}

void OgreTechniqueGroup::update(unsigned long frameNum)
{
	for(unsigned int i = 0; i < renderTechniques.size(); i++ )
	{
		renderTechniques.at(i)->update(frameNum);
	}
}

void OgreTechniqueGroup::runChanged(RenderingRunType runType, RenderingRun* run)
{
	for(unsigned int i = 0; i < renderTechniques.size(); i++ )
	{
		renderTechniques.at(i)->runChanged(runType, run);
	}
}

void OgreTechniqueGroup::runUpdated(RenderingRunType runType, RenderingRun* run)
{
	for(unsigned int i = 0; i < renderTechniques.size(); i++ )
	{
		renderTechniques.at(i)->runUpdated(runType, run);
	}
}
